#!/usr/bin/perl

# static char sccsid[] = "@(#)25 1.8 src/ll/config_editor/cgi-bin/pull_down_tab_panel_groups.pl, ll.config, ll_rrur2, rrur21042a 1/2/10 03:57:45\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my ($mysql_host, $mysql_user, $mysql_pass, $mysql_db) = get_db_info(0);

my @normal_tables_by_groupID = @{LLUtil::ALL_TABLES->{"tab_panel_groups"}->[0]};
my @multi_select_tables_by_groupID = @{LLUtil::ALL_TABLES->{"tab_panel_groups"}->[1]};

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

$_ = $query;
if(/id=(\d+)&name=(.*)&cluster=(\d+)/)
{
	my $json_str_0 = "Content-type: text/html\n\n";
	my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
	if(!defined($dbh))
	{
		my $json_str_err = $json_str_0."Error:".DBI->errstr;
		print $json_str_err;
		exit 1;
	}
	
	my $groupID = $1;
	my $option_name = $2;
	my $cluster_id = $3;

	my $sql_str;
	my $sth;

	my $json_str = $json_str_0."[";

	# Get default group id
	my $default_group_id = undef;
	if($groupID != 0)
	{
		$default_group_id = get_default_id_by_primary_key($dbh,"groupID","clusterID","TLLS_CFGGroup","name",$groupID);
	}
	else
	{
		$default_group_id = get_default_id($dbh,"groupID","name","TLLS_CFGGroup",$cluster_id);
	}
	
	# Get default values
	if(defined($default_group_id))
	{
		my $is_default = 0;
		if($default_group_id == $groupID) { $is_default = 1; }		
		$json_str .= get_default_json_str($dbh,"tab_panel_groups","groupID",$default_group_id,$is_default);
	}

	if($groupID != 0)
	{
		
	foreach my $table (@normal_tables_by_groupID)
	{
		$sql_str="select * from ".$table." where groupID=".$groupID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}
		my $ary_ref = $sth->fetchrow_arrayref;
		my $i = 0;
		$json_str .= "{type:'normal',id:'".$table."-id"."',value:'".$groupID."'},";
		if(exists $ary_ref->[$i])
		{
			for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
			{
				if($sth->{NAME}->[$i] ne "userListType")
				{
					$json_str .= "{type:'normal',id:'".$table."-".$sth->{NAME}->[$i]."',value:'".$ary_ref->[$i]."'},";
				}
				else
				{
					$json_str .= "{type:'radio',id:'".$table."-".$sth->{NAME}->[$i]."',value:'".$ary_ref->[$i]."'},";
				}
			}
		}
	}
	
	foreach my $table (@multi_select_tables_by_groupID)
	{
		$sql_str="select * from ".$table." where groupID=".$groupID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}
		$json_str .= "{type:'multisel',table_name:'".$table."',key_id:'".$groupID."',values:[";
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
		    $json_str .= "{a:'".$ary_ref->[1]."'},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}

	} # $groupID != 0
	
	$json_str =~ s/,$//g;
	$json_str .= "]";
	print $json_str;
	if(defined($sth)) {$sth->finish();}
	$dbh->disconnect();

}
