#!/usr/bin/perl -wT

# static char sccsid[] = "@(#)36 1.13 src/ll/config_editor/cgi-bin/show_tab_panel_daemons.pl, ll.config, ll_rrur2, rrur21042a 1/12/10 03:38:01\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use HTML::Template;
use DBI;

my ($mysql_host, $mysql_user, $mysql_pass, $mysql_db) = get_db_info(1);

my @normal_tables_by_nodeID = ();

# Create a HTML::Template
use constant TMPL_FILE => LLUtil::TMPL_DIR."/show_tab_panel_daemons.tmpl";
my $tmpl = new HTML::Template(filename => TMPL_FILE);

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

## The first pair of params tells which sub panel it is; pass it to template for TMPL_IF
my @pairs = split('&',$query);
my @tmp = split('=',$pairs[0]);
my $subpanel = $tmp[0];
$tmpl->param($subpanel => 1);
if($subpanel eq "tab_panel_daemons")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_daemons"}->[0]};
}
elsif($subpanel eq "tab_panel_cm")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_cm"}->[0]};
}
elsif($subpanel eq "tab_panel_resmgr")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_resmgr"}->[0]};
}
elsif($subpanel eq "tab_panel_regmgr")
{
	@normal_tables_by_nodeID  = @{LLUtil::ALL_TABLES->{"tab_panel_regmgr"}->[0]};
}
elsif($subpanel eq "tab_panel_master")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_master"}->[0]};
}
elsif($subpanel eq "tab_panel_startd")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_startd"}->[0]};
}
elsif($subpanel eq "tab_panel_starter")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_starter"}->[0]};
}
elsif($subpanel eq "tab_panel_schedd")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_schedd"}->[0]};
}
elsif($subpanel eq "tab_panel_kbdd")
{
	@normal_tables_by_nodeID = @{LLUtil::ALL_TABLES->{"tab_panel_kbdd"}->[0]};
}
else
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => "Unknown sub panel name.");
	print $tmpl->output;
	exit 1;
}

# Connect to db
my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
if(!defined($dbh))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => DBI->errstr);
	print $tmpl->output;
	exit 1;
}

# Get default node id and name
my $default_node_id = undef;
my $default_node_name = undef;

# Get node id and name
my $sql_str="select nodeID,hostname from TLL_Nodelist";
my $sth=$dbh->prepare($sql_str);
if(!defined($sth->execute()))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => $dbh->errstr);
	print $tmpl->output;
	exit 1;
}
my($id,$name);
$sth->bind_columns(undef,\$id,\$name);
my @pull_down=();
while($sth->fetch())
{
	if( (!defined($default_node_id)) && ($name eq "default" || $name eq "Default") )
	{
		$default_node_id = $id;
		$default_node_name = $name;
	}
	else
	{
		my %pair = (id => $id, name => $name);
		push @pull_down, \%pair;
	}
}
if(defined($default_node_id))
{
	my %pair = (id => $default_node_id, name => $default_node_name);
	@pull_down = (\%pair, @pull_down);
}
elsif(scalar(@pull_down) > 0)
{
	my %pair = %{$pull_down[0]};
	$default_node_id = $pair{"id"};
	$default_node_name = $pair{"name"};
}
$tmpl->param(pull_down => \@pull_down);

# Show normal tables
foreach my $table (@normal_tables_by_nodeID)
{
	my @table_items = ();
	my $ary_ref = undef;
	if(defined($default_node_id))
	{
		$sql_str="select * from ".$table." where nodeID=".$default_node_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		$ary_ref = $sth->fetchrow_arrayref;
	}

	if(!defined($ary_ref))
	{
		$sql_str="select * from ".$table." limit 1";
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
	}

	for(my $m=1;$m<$sth->{NUM_OF_FIELDS};$m++)
	{
		my $default = "";
		my $value = "";
		if(defined($ary_ref))
		{
			$value = $ary_ref->[$m];
		}

		#$sth->{TYPE}->[$m]
		my %item = (id => $table."-".$sth->{NAME}->[$m],
			    name => $table."-".$sth->{NAME}->[$m],
			    title => $table."-".$sth->{NAME}->[$m],
			    display_name => $sth->{NAME}->[$m],
			    value => $value,
			    orig_id => "orig-".$table."-".$sth->{NAME}->[$m],
			    orig_name => "orig-".$table."-".$sth->{NAME}->[$m],
			    orig_value => $value,
			    default => $default);
		push @table_items, \%item;
	}

	$tmpl->param($table."_items" => \@table_items);
	$tmpl->param($table."-id" => $default_node_id);
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]);
}

$sth->finish();
$dbh->disconnect();


print "Content-type: text/html\n\n";
print $tmpl->output;

