#!/usr/bin/perl -wT

# static char sccsid[] = "@(#)37 1.10 src/ll/config_editor/cgi-bin/show_tab_panel_groups.pl, ll.config, ll_rrur2, rrur21042a 1/2/10 03:58:16\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use HTML::Template;
use DBI;

my ($mysql_host, $mysql_user, $mysql_pass, $mysql_db) = get_db_info(1);

my @normal_tables_by_groupID = @{LLUtil::ALL_TABLES->{"tab_panel_groups"}->[0]};
my @multi_select_tables_by_groupID = @{LLUtil::ALL_TABLES->{"tab_panel_groups"}->[1]};

# Create a HTML::Template
use constant TMPL_FILE => LLUtil::TMPL_DIR."/show_tab_panel_groups.tmpl";
my $tmpl = new HTML::Template(filename => TMPL_FILE);

# Connect to db
my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
if(!defined($dbh))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => DBI->errstr);
	print $tmpl->output;
	exit 1;
}

# Get cluster id and name
my $primary_cluster_id;
my $sql_str="select clusterID,name from TLL_Cluster;";
my $sth=$dbh->prepare($sql_str);
if(!defined($sth->execute()))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => $dbh->errstr);
	print $tmpl->output;
	exit 1;
}
my($id,$name);
$sth->bind_columns(undef,\$id,\$name);
my @pull_down_cluster=();
if($sth->fetch())
{
	$primary_cluster_id = $id;
	my %pair = (id => $id, name => $name);
	push @pull_down_cluster, \%pair;
	while($sth->fetch())
	{
		my %pair = (id => $id, name => $name);
		push @pull_down_cluster, \%pair;
	}
}
$tmpl->param(pull_down_cluster => \@pull_down_cluster);

# Get default group id and name
my $default_group_id;

# Get group id and name
if(defined($primary_cluster_id))
{
	$sql_str="select groupID,name from TLLS_CFGGroup where clusterID=".$primary_cluster_id;
	$tmpl->param("TLLS_CFGGroup-clusterID" => $primary_cluster_id);
}
else
{
	$sql_str="select groupID,name from TLLS_CFGGroup;";
	$tmpl->param("TLLS_CFGGroup-clusterID" => 1);
}
$sth=$dbh->prepare($sql_str);
if(!defined($sth->execute()))
{
	print "Content-type: text/html\n\n";
	$tmpl->param(error_string => $dbh->errstr);
	print $tmpl->output;
	exit 1;
}
$sth->bind_columns(undef,\$id,\$name);
my @pull_down=();
while($sth->fetch())
{
	if($name eq "default" || $name eq "Default")
	{
		$default_group_id = $id;
	}
	my %pair = (id => $id, name => $name);
	push @pull_down, \%pair;
}
$tmpl->param(pull_down => \@pull_down);

# Show normal tables
foreach my $table (@normal_tables_by_groupID)
{
	my @table_items = ();
	my $ary_ref = undef;
	if(defined($default_group_id))
	{
		$sql_str="select * from ".$table." where groupID=".$default_group_id;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
		
		$ary_ref = $sth->fetchrow_arrayref;
	}
	if(!defined($ary_ref))
	{
		$sql_str="select * from ".$table." limit 1";
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			print "Content-type: text/html\n\n";
			$tmpl->param(error_string => $dbh->errstr);
			print $tmpl->output;
			exit 1;
		}
	}
	
	for(my $m=1;$m<$sth->{NUM_OF_FIELDS};$m++)
	{
		if($sth->{NAME}->[$m] ne "clusterID" && $sth->{NAME}->[$m] ne "userListType")
		{
			my $default = "";
			if(defined($default_group_id) && defined($ary_ref) && exists $ary_ref->[$m])
			{
				$default = $ary_ref->[$m];
			}

			#$sth->{TYPE}->[$m]
			my %item = (id => $table."-".$sth->{NAME}->[$m],
				    name => $table."-".$sth->{NAME}->[$m],
				    title => $table."-".$sth->{NAME}->[$m],
				    display_name => $sth->{NAME}->[$m],
				    orig_id => "orig-".$table."-".$sth->{NAME}->[$m],
				    orig_name => "orig-".$table."-".$sth->{NAME}->[$m],
				    default => $default);
			push @table_items, \%item;
		}
	}
	$tmpl->param($table."_items" => \@table_items);
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]);
	
}


foreach my $table (@multi_select_tables_by_groupID)
{
        $sql_str="select * from ".$table." limit 1";
	$sth=$dbh->prepare($sql_str);
	if(!defined($sth->execute()))
	{
		print "Content-type: text/html\n\n";
		$tmpl->param(error_string => $dbh->errstr);
		print $tmpl->output;
		exit 1;
	}
	$tmpl->param($table."-primary_key" => $sth->{NAME}->[0]."-".$sth->{NAME}->[1]);
	
	my $default_str = "";
	if(defined($default_group_id))
	{
		$sql_str = "select * from ".$table." where groupID=".$default_group_id;
		$default_str = get_default_keyword_str($dbh,$sql_str,$table);
	}
	$tmpl->param($table."_default_str" => $default_str);
}
$sth->finish();
$dbh->disconnect();


print "Content-type: text/html\n\n";
print $tmpl->output;

